﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data.SqlClient;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Dapper;
using Newtonsoft.Json;
using Npgsql;
using Xunit;
using Xunit.Abstractions;

namespace SpatialPerfomance.IntegrationTests
{
    public class SpatialData
    {
        public long InformationResourceId { get; set; }
        public long DemopictureId { get; set; }
        public string Cordinates { get; set; }
        public DateTime? AcquisitionTime { get; set; }
        public double? SunElevation { get; set; }
    }

    public class ReadDataFromMonitoring
    {
        private Func<SqlConnection> getConnection;
        private Func<SqlConnection> getConnectionServer2016;
        private Func<NpgsqlConnection> getConnectionPg9;
        private ITestOutputHelper _out;
        //Todo remove static file path
        private string fileName = "d:\\GitLabRepository\\test-spatial-perfomance\\data.json";

        public ReadDataFromMonitoring(ITestOutputHelper output)
        {
            _out = output;
            var connectionString = ConfigurationManager.ConnectionStrings["Monitoring"].ConnectionString;
            var connectionStringServer2016 = ConfigurationManager.ConnectionStrings["Server2016"].ConnectionString;
            var connectionStringPg9 = ConfigurationManager.ConnectionStrings["Pg9"].ConnectionString;
            getConnection =()=> new SqlConnection(connectionString);
            getConnectionServer2016 =()=> new SqlConnection(connectionStringServer2016);
            getConnectionPg9 =()=> new NpgsqlConnection(connectionStringPg9);
        }

        [Fact]
        public void Read()
        {
            var script = @"
SELECT [information_resource_id] as InformationResourceId
      ,[demo_picture].[id]      as DemopictureId
      ,[coordinates].STAsText()      as Cordinates
      ,[acquisition_time]      as AcquisitionTime 
      ,[sun_elevation]     as SunElevation
  FROM [dbo].[demo_picture]
  join dbo.information_resource on information_resource_id = information_resource.id
  where schema_id = 5 

";



            var conn = getConnection.Invoke();
            var listData = conn.Query<SpatialData>(script);

            var content = JsonConvert.SerializeObject(listData);

            File.WriteAllText(fileName,content);
        }

        [Fact]
        public void CreateSqlServer2016Tables()
        {
            var createTableScript = @"
  CREATE table demo (
    id bigint not null ,
    demo_id bigint not null ,
    coordinates geography,
	acquisition_time datetime,
	sun_elevation float ,
	primary key (id, demo_id)
);

CREATE SPATIAL INDEX SPATIAL_demo
                           ON[dbo].[demo]([coordinates])
                           USING GEOGRAPHY_GRID
                           WITH(
                            GRIDS = (MEDIUM, MEDIUM, MEDIUM, LOW)
                           );
";
            var fillDataSql = @"
insert into 
	                            demo([id],
[demo_id],
				                            [coordinates], 
				                            [acquisition_time],
				                            [sun_elevation])
values(
@InformationResourceId,
@DemopictureId,
(geography::STGeomFromText(''+@Cordinates+'', 4326)),
@AcquisitionTime,
@SunElevation
)
";

            var content = JsonConvert.DeserializeObject<IEnumerable<SpatialData>>(File.ReadAllText(fileName));

            var conn = getConnectionServer2016.Invoke();

            foreach (var spatialData in content)
            {
                conn.Execute(fillDataSql, spatialData);
            }
            
        }



        [Fact]
        public void FillPostgres96Data()
        {
            var createTableScript = @"
CREATE TABLE public.demo
(
    id BIGINT NOT NULL,
    demo_id BIGINT NOT NULL,
    coordinates GEOGRAPHY,
    acquisition_time TIME,
    sun_elevation FLOAT,
    CONSTRAINT demo_id_demo_id_pk PRIMARY KEY (id, demo_id)
);
CREATE INDEX demo_coordinates_gix ON demo USING GIST (coordinates);
";
            var fillDataSql = @"
insert into 
	                            demo(id,
demo_id,
				                            coordinates, 
				                            acquisition_time,
				                            sun_elevation)
values(
@InformationResourceId,
@DemopictureId,
(ST_GeomFromText(@Cordinates, 4326)),
@AcquisitionTime,
@SunElevation
);
";

            var content = JsonConvert.DeserializeObject<IEnumerable<SpatialData>>(File.ReadAllText(fileName));

            var conn = getConnectionPg9.Invoke();

            foreach (var spatialData in content)
            {
                conn.Execute(fillDataSql, spatialData);
            }
        }

        

        [Theory]
        [InlineData("GEOMETRYCOLLECTION(POINT (-74.53125 73.022591571472987),POINT (-111.796875 -80.454651917434745),POINT (137.8125 -80.098433067697954),POINT (114.37500000000001 71.450493148476852),POINT (0 0))")]
        [InlineData("GEOMETRYCOLLECTION(POINT (27.716674804687486 53.928063667694744))")]
        [InlineData("GEOMETRYCOLLECTION(POLYGON ((29.765624999999986 67.2493939391629, 85.078125 67.698330442833949, 87.421874999999986 46.558860303117179, 31.171874999999986 47.04018214480665, 29.765624999999986 67.2493939391629)))")]
        [InlineData("GEOMETRYCOLLECTION(POLYGON ((29.755624999999986 67.2493939391629, 85.078125 67.698330442833949, 87.421874999999986 46.558860303117179, 31.171874999999986 47.04018214480665, 29.765624999999986 67.2493939391629)),POINT (22.5 57.452831052911208),POINT (54.140625 69.819417960543518),POINT (95.625 60.586967342258674),POINT (61.406249999999986 42.897429949578083),LINESTRING (112.26562500000001 67.875541346729435, 137.109375 68.138851649255741, 135.703125 58.201590836983328, 112.26562500000001 57.578706092220877, 104.765625 72.677043709542573))")]
        [InlineData("GEOMETRYCOLLECTION(POLYGON ((102.77667370876898 57.854577032286691, 102.77798829351647 57.853648748806627, 102.77857968095174 57.852343305551074, 102.7784925748754 57.85076927626006, 102.77852485110758 57.850579066423059, 102.77667370876898 57.854577032286691)),POLYGON ((97.276757476242508 59.644629542141381, 97.279879370222233 59.647018133550347, 97.281097449189389 59.6482627726276, 97.281470237687316 59.648911975584859, 97.281214183489254 59.649461662970992, 97.28016324659589 59.65076718229264, 97.279648405973745 59.651840026422896, 97.279520274548887 59.652994681286181, 97.279982179723092 59.6546253024519, 97.280591739125839 59.655447716247352, 97.283660037892972 59.6581593499262, 97.286689863826709 59.6602189874613, 97.2881500855331 59.661028434964742, 97.289406999402757 59.661199173893714, 97.291108908190125 59.661158934532672, 97.299138136514557 59.65999598896471, 97.302175565388936 59.659861001949849, 97.312621425088921 59.658869618494535, 97.320602175390491 59.658870395027655, 97.324078440271492 59.659135710182049, 97.326128836589348 59.659609960576155, 97.330114586162452 59.660855296240591, 97.3339609873069 59.661576464625476, 97.343025107682863 59.662440800799615, 97.345375166575323 59.664008172377649, 97.347482169148691 59.664918458874382, 97.354549490581221 59.666716779856969, 97.355930801839477 59.66697356385319, 97.358274420277084 59.6671187183498, 97.359637553743482 59.667600691050517, 97.362046292339471 59.669426989442158, 97.369963530967013 59.672673034137873, 97.374761045128977 59.674457388468433, 97.3760614519128 59.676199837948324, 97.377217710028034 59.676988901987023, 97.378649909703185 59.677600124192544, 97.3833336655502 59.679050973138466, 97.3847371870415 59.679690762276643, 97.385960588824616 59.680327698758532, 97.388391594267262 59.682353891276541, 97.389618411742447 59.683061572349807, 97.391784151306041 59.683656036327271, 97.398605007296638 59.684657589288776, 97.402194488832777 59.685707765115239, 97.404411165217141 59.686690854194822, 97.406362744579354 59.6877161719686, 97.408253233397474 59.689670925902625, 97.409953044823652 59.691919360791118, 97.412643175368 59.6940560451903, 97.41551298565571 59.695082806762535, 97.42244832421045 59.696100242042384, 97.419400718060047 59.698752248273237, 97.418799069980182 59.69973225856485, 97.418328693072326 59.7011926311144, 97.418058587056279 59.702574807524208, 97.418308353024429 59.703997372803471, 97.418704594057687 59.704796840837858, 97.41996572974557 59.706054810822337, 97.421441673894492 59.706936544373065, 97.423040212889617 59.707578147260605, 97.436470458482347 59.711707139733186, 97.437377111759616 59.712141743269946, 97.438510091616166 59.713070318834625, 97.440359979830163 59.716740654448948, 97.441443133152291 59.721114993275705, 97.442750528166755 59.723392655034836, 97.438453617027051 59.727372343259439, 97.437596753121539 59.728593853657294, 97.4372970704732 59.729272694288689, 97.4372040684885 59.730037586164819, 97.437328914466349 59.730593968459196, 97.437744446465871 59.73122376824071, 97.439472126509244 59.731868951645104, 97.444298799301819 59.73292295908815, 97.4461448147454 59.733620361319311, 97.448874948761713 59.735154954949557, 97.450845088667492 59.735957925321372, 97.454553392665176 59.737053445658084, 97.458352129032136 59.737918287116486, 97.463721515386254 59.738245202939922, 97.472194291433567 59.737800510359165, 97.475327022023819 59.738327648519068, 97.480841584750337 59.73960322468583, 97.484359137249982 59.740165244105057, 97.488812908778982 59.740435260848933, 97.491426369001843 59.740084264626134, 97.49537780614952 59.738716949739732, 97.49961232406352 59.738398863671236, 97.503840219811408 59.737677346309169, 97.510525700772263 59.735319074149949, 97.514727601332723 59.733040743940393, 97.5172055836155 59.7314634615413, 97.51962555656425 59.729288966900015, 97.52727902039058 59.724682105071437, 97.527986381440272 59.723901082077667, 97.528311296362446 59.7231360898648, 97.528494239922992 59.723043919126859, 97.53786108812146 59.723109758480327, 97.539983290277618 59.7228660608614, 97.5418038422449 59.722538269124222, 97.54401860201493 59.721596983111112, 97.547088727018092 59.719416628985613, 97.548431272503322 59.718816691662688, 97.550251559805943 59.718572774212191, 97.553754220632669 59.71853508760816, 97.559550267985671 59.717634846818385, 97.560811780163249 59.717623735741981, 97.56282571708546 59.71824691683959, 97.564281198815522 59.718247209997394, 97.566424382041916 59.7178015133906, 97.569587037988342 59.716646122889685, 97.571057691285432 59.716007895132023, 97.571995132354175 59.715281409472162, 97.572708341857137 59.713817539575111, 97.573970960043226 59.710109036994822, 97.575690245802363 59.709053672594052, 97.5773899692251 59.708352931238814, 97.5793114530616 59.70706014715509, 97.580203512440136 59.706747225706174, 97.582151909857132 59.70642859901254, 97.583243762575265 59.706457231729388, 97.590559168228424 59.708010715039073, 97.598610837436127 59.71016674414026, 97.602443546062162 59.709940050687209, 97.60360244506218 59.709674613687213, 97.60487827211837 59.709092993479828, 97.608603366398526 59.706863691893034, 97.609340572006332 59.70600712115823, 97.609741582002385 59.705211743287407, 97.610250944023065 59.702425631444939, 97.610773632396558 59.701583275327657, 97.613687292264487 59.700186626434672, 97.623493068582789 59.696095791721305, 97.631888967474822 59.696158349952242, 97.63507023641148 59.695916664125733, 97.642383875977671 59.694315896796077, 97.646636998029166 59.693578165991944, 97.6554718831734 59.690922773545545, 97.66046663066615 59.689903071048754, 97.663628257698349 59.689603700986339, 97.667575586229063 59.689769634396342, 97.668604176810234 59.689679412781985, 97.674600334112355 59.688166791121937, 97.678942856144786 59.6879182725666, 97.684024183936117 59.688050866060173, 97.685275268991731 59.687946248514628, 97.691614755559669 59.6866326700714, 97.693204399811918 59.686429023337588, 97.69616048564545 59.68647041810766, 97.702521186632453 59.687144806294548, 97.70513396638583 59.687703205847136, 97.713025569974562 59.69060090286046, 97.714869924065113 59.690839845030794, 97.717774420114523 59.690948444124167, 97.724485930837261 59.69011144231203, 97.731473799403048 59.6896106110368, 97.733371520845125 59.689696891542219, 97.740580749597029 59.690701637699263, 97.742352621597036 59.690803837699278, 97.745735678570426 59.690643094548243, 97.751165072310187 59.69164634650128, 97.756198766143626 59.691952360882993, 97.757748211108691 59.69218717794287, 97.7593374620205 59.693283964712279, 97.759269652363685 59.695897225993896, 97.759736496096821 59.696995086412436, 97.7606424020576 59.697825325753129, 97.762693523491848 59.698625545226648, 97.767029876134785 59.699523354372566, 97.772148197575433 59.702575331444123, 97.773363671301638 59.703155531433261, 97.7749640699933 59.703746964843546, 97.7791644882047 59.70470542844599, 97.780871462202583 59.705329927228469, 97.782691639535869 59.706837393734595, 97.78401902340579 59.708473735265265, 97.785416163579328 59.709825497625189, 97.7878941360965 59.710805891445091, 97.789080072086378 59.710994845282571, 97.791868752997047 59.710962679615143, 97.800790174778143 59.709869995195319, 97.803807600800951 59.70933360757116, 97.808041915182045 59.707915381992215, 97.813218373853829 59.707331823124107, 97.8214771647349 59.707037959994921, 97.827523188824173 59.707449720926945, 97.833449525149149 59.707507518204032, 97.841056752928054 59.706651084615437, 97.843721077958392 59.706628553349439, 97.8460999638888 59.7071606817916, 97.850638882915192 59.709210165603125, 97.85335293344508 59.710089553421888, 97.854900868352416 59.710325248965596, 97.859897824976073 59.71046831835509, 97.868390306496835 59.7115072252316, 97.8750182614355 59.711661202684049, 97.87666031100612 59.71253673156761, 97.877645736716772 59.712642174382374, 97.878855812012517 59.7124811672135, 97.880697162012524 59.711850585213512, 97.884205693618327 59.710185223986478, 97.887144479306855 59.709187988082206, 97.8886681974013 59.709351666872777, 97.890570046279052 59.709860645352528, 97.893250277348088 59.710302640508615, 97.895554927569563 59.710430618431964, 97.903748198042734 59.709881611103285, 97.9072640113116 59.710121751903614, 97.9084069733405 59.710057327476342, 97.91619599232088 59.7084112628325, 97.918748448050522 59.708367621344358, 97.919371937417026 59.708526852620508, 97.920095657113791 59.70898065606039, 97.921615744448928 59.710574171492162, 97.92322674174342 59.711584283548682, 97.924154877299543 59.712431914064339, 97.923466272272876 59.716747676969931, 97.923402252794958 59.718743650917048, 97.923544397833737 59.719588847015309, 97.923799686766259 59.720485995152288, 97.924350032389242 59.7215028289948, 97.926706543850827 59.72385505182482, 97.9287095168556 59.725172169149396, 97.931805427841155 59.726814192334025, 97.934415879654921 59.727786061966825, 97.936702259193368 59.728019054010637, 97.94135214309695 59.728002328875142, 97.9425915396326 59.7282016281515, 97.946589752876577 59.729409233482158, 97.947081423813231 59.729714971231267, 97.965194863636285 59.687658392045449, 98.051005863636277 59.486949392045446, 98.11474234005928 59.3367844518444, 98.1190127443181 59.337444255681817, 98.1706707443181 59.228091255681818, 98.249252423258 59.060676186558567, 98.24190487644637 59.060497627741043, 98.241005398689751 59.030100955573161, 98.241045756062263 59.026174010519057, 98.2394881782287 59.011035731920707, 98.239605507493351 58.9895515667893, 98.239463863729569 58.960025631644037, 98.239643356582292 58.953852344985869, 98.239462088511374 58.953248504178838, 98.238724198898566 58.952836570232705, 98.242134659431542 58.919613735401093, 98.24341361900315 58.88448841770294, 98.24430699731694 58.8518222354462, 98.244100397420041 58.850864443969584, 98.243614628518216 58.850490256943651, 98.239763944840746 58.850307526394346, 98.240964455652531 58.81385736334515, 98.2395581043732 58.779143023763339, 98.240514630171546 58.778940698098751, 98.2407401582164 58.778699414794254, 98.240903841322236 58.778068834580026, 98.239567711287066 58.760923290970091, 98.240145745828258 58.742585671895434, 98.241920150023844 58.707270720407195, 98.242170393428893 58.697908970541093, 98.243655840692313 58.670640569398465, 98.243166975477237 58.637882834951192, 98.2466460641213 58.637736808914092, 98.24712219158323 58.637393056518974, 98.247323249162832 58.636841296680956, 98.24908071434092 58.602694351337746, 98.249431719211287 58.601094485453714, 98.2492902877377 58.600683319295243, 98.24571121588923 58.562491771269769, 98.246910905166 58.530359999969818, 98.24718905010505 58.526052088920721, 98.247175659390521 58.523735643697741, 98.2493772249879 58.47986005216783, 98.250639864884178 58.445802857891962, 98.253023791696521 58.425643694204275, 98.254296370315274 58.416982638313996, 98.254185273744469 58.416359122693656, 98.253721886315844 58.415927397934311, 98.248577919348051 58.415340115574438, 98.242695847348088 58.415539076574461, 98.238029179107158 58.415982483667662, 98.233457598158 58.417484582361134, 98.228134801046565 58.418917034580616, 98.221161356857692 58.419953709153909, 98.21425379212603 58.42131344677108, 98.196957370524274 58.423080961293195, 98.184450950482315 58.424047664841083, 98.1740175901668 58.423652179720726, 98.16915205787339 58.422987140307171, 98.158056630856208 58.421895144192383, 98.136542924487571 58.42162518440167, 98.1276686592454 58.421981393184915, 98.120909424989236 58.422053385605793, 98.095820410374657 58.421365641984174, 98.069727741597745 58.419313909265519, 98.064939714203575 58.4194593396373, 98.056912802203243 58.419047360463523, 98.0400099616136 58.417630092306418, 98.025634861427477 58.417372679726704, 98.0099400934644 58.41835927850655, 98.004026402566879 58.4182219417789, 97.986526917943692 58.417059515818345, 97.9756154165642 58.41548432391793, 97.968212503920881 58.414612892466671, 97.961734863167209 58.414803078585123, 97.954063473652823 58.415776314138228, 97.939985640946787 58.41613079508312, 97.914088653354057 58.41807696469477, 97.890986143211492 58.419532880993621, 97.862452239941319 58.419062949394558, 97.840398885942577 58.418362843626916, 97.8346824916822 58.416139666132253, 97.823735219030979 58.41587318881917, 97.775645062499919 58.518902642045461, 97.681471062499924 58.719028642045458, 97.586543062499928 58.919104642045461, 97.490849062499919 59.119130642045455, 97.438239062499932 59.228389642045457, 97.456478251159155 59.231207709361655, 97.3921871818181 59.379969778409091, 97.304867181818111 59.580541778409085, 97.276757476242508 59.644629542141381)),POLYGON ((85.699668645498633 61.300673456134014, 85.700557389995183 61.308714191564363, 85.701156497949157 61.31600627761182, 85.700876075715513 61.316482649775693, 85.69831021272789 61.318744106037123, 85.694500232478475 61.321442483747845, 85.68845748109851 61.326425238842006, 85.68634479545446 61.331278028409095, 85.664077862060864 61.38204476314182, 85.723902632241547 61.415002755203886, 85.736955861007715 61.422464296890759, 85.747666943911355 61.428357205088808, 85.755452961030713 61.432380368399571, 85.786422709053639 61.449364534264014, 85.798415735635785 61.45612301943887, 85.885475523362246 61.459215302000615, 85.966306341779671 61.461437461129172, 85.973502471443609 61.45917720288449, 85.9832860013712 61.457065721770178, 86.000886113899867 61.45280484589194, 86.0060811832479 61.451148344329454, 86.022290560477771 61.445188398769673, 86.029661139378291 61.443071262912405, 86.043245475638074 61.439599261254095, 86.048357558060232 61.437471750435925, 86.049917310286816 61.436551078326644, 86.05200688555766 61.434938679004652, 86.0550681186024 61.432949880401758, 86.061447215353652 61.428156849760761, 86.067476117049381 61.422709058742363, 86.07170060643935 61.418581909008211, 86.077416240282886 61.412508405262138, 86.082620371740433 61.407543491376487, 86.085845187151065 61.405203689425313, 86.091416979354435 61.402041663285068, 86.096146153158671 61.400172438755348, 86.101772429139416 61.397332755367209, 86.111974811962554 61.390241504182185, 86.118783486040243 61.385869801092149, 86.125550943174531 61.382061822506905, 86.1315283272462 61.379698867673525, 86.1332024527017 61.379301451002725, 86.137647579422008 61.378662491284366, 86.147600836690685 61.377535358319335, 86.163553003390874 61.375442847075846, 86.171674930755017 61.374642494999, 86.1817490326845 61.373305945619009, 86.193733153216783 61.372637192206156, 86.195508725832426 61.372790741023451, 86.201212062517328 61.375587826911342, 86.203082028725746 61.376680547329421, 86.207188250614578 61.379632894765649, 86.220118876852951 61.386168138628541, 86.22107279725283 61.387061084834521, 86.222113675447517 61.38916384966722, 86.2234636342712 61.390949982089445, 86.224789712271175 61.392105999089473, 86.226342651701728 61.3930687126447, 86.232357970868236 61.39868347613492, 86.235899441756942 61.401814559975328, 86.238605038291681 61.403929112774485, 86.2404071984001 61.405614226528471, 86.243434120569759 61.407813297003834, 86.246736415956477 61.409919754973011, 86.252452722408222 61.414072875521029, 86.255285677057159 61.416648854046585, 86.2613238787405 61.42059821891516, 86.263419854153355 61.422650151064332, 86.265994130609741 61.4256476839829, 86.266795585546149 61.427123765304373, 86.267125794163363 61.429104490665019, 86.269038409774311 61.432844509609879, 86.27021982909892 61.434413997133376, 86.271302845234914 61.435524656788182, 86.273384396349741 61.437235438175819, 86.27681602962025 61.439507189248559, 86.281095721332036 61.442630691454163, 86.286238839322749 61.445999936492676, 86.2923576689116 61.449471742250417, 86.295203122021817 61.450818349979443, 86.298997539559949 61.452342748435171, 86.379430863636259 61.26421194886364, 86.443167340059262 61.114047008662595, 86.44743774431808 61.11470681250001, 86.499095744318083 61.005353812500012, 86.593063744318087 60.805158812500011, 86.686283744318089 60.604916812500015, 86.778768744318086 60.404628812500015, 86.870533744318081 60.204294812500009, 86.947761508889386 60.034346404519972, 86.939140049682734 60.034171750471756, 86.853396902898382 60.032982316257268, 86.855946696073644 59.997775162975792, 86.857527420588212 59.961854506784995, 86.856137547287119 59.9103535332786, 86.855901319148913 59.9097308680776, 86.8553264649445 59.909394626602655, 86.848222675337681 59.910408481186387, 86.844822189276911 59.911216537061414, 86.821224904681216 59.915891532478561, 86.816099406273779 59.916642200244958, 86.806070806174759 59.919218219422746, 86.796991680715763 59.921223656678364, 86.766373082921248 59.927060665070591, 86.754852812294274 59.929438948537474, 86.688527297389641 59.939082335936178, 86.63946581058309 59.946468271140738, 86.62655488119448 59.947672177628775, 86.619502410157111 59.947516861217728, 86.567685754366948 59.947573204309272, 86.565981256865072 59.947591203987123, 86.564091836777578 59.947850766808195, 86.561604681659091 59.947553254798848, 86.386322053112139 59.948406414462404, 86.306142701289289 59.949412979642027, 86.250555676136273 60.069465892045471, 86.157122676136268 60.269638892045471, 86.062948676136273 60.469764892045468, 85.968020676136277 60.669840892045471, 85.872326676136268 60.869866892045465, 85.819716676136281 60.979125892045467, 85.8379558647955 60.981943959361665, 85.773664795454451 61.1307060284091, 85.699668645498633 61.300673456134014)),POLYGON ((87.255429262755143 57.804351888327375, 87.286781781107365 57.801493870870488, 87.406990777341761 57.7879405225631, 87.432019573927818 57.7854884490152, 87.444529762501617 57.820680945512841, 87.444905038478424 57.821169744276489, 87.445495621659319 57.82134572096971, 87.685521246224155 57.81567433496091, 87.75337791192014 58.000053632297906, 87.811648196366747 58.086794426762715, 87.892852778409 57.91379136931819, 87.986072778409 57.713549369318194, 88.078557778408992 57.513261369318194, 88.152040284704853 57.352840245618793, 88.134632870358075 57.33929069550954, 88.1559367535422 57.306606048535109, 88.156036039001378 57.305710775272985, 88.155375037424136 57.305098853111957, 88.139723888567445 57.300657973383018, 88.112523888567452 57.301858973383055, 88.0996756729743 57.305343959038844, 88.088026560335 57.318539613818963, 88.067772697309579 57.345871045822328, 88.065550893732691 57.3448729515814, 88.064018688347559 57.341523520514173, 88.06145951113497 57.330406660863964, 88.057043094581829 57.320779234874323, 88.056620642931208 57.320323842723909, 88.0535156429312 57.318598842723944, 88.044125213549478 57.317534445056332, 88.039578644034663 57.317432460848536, 88.0333476067373 57.318828815390226, 88.029213710646289 57.320489219200233, 88.026705446305726 57.3211784589765, 88.024192183973071 57.320213212171538, 88.022524350144721 57.319366904445189, 88.020944411920112 57.318039520482429, 88.020459624183971 57.316880017967954, 88.020895048115051 57.316214145783121, 88.020799291092928 57.315608539475136, 88.019355291092936 57.312754539475122, 88.0188954097251 57.312304322768604, 88.014277395783949 57.310124879176307, 88.008080012972428 57.310452456793179, 88.006989269242013 57.308387022583354, 88.006418163265181 57.307904300695341, 87.997127736344254 57.304949885811283, 87.987308736344261 57.306340885811238, 87.981643272500719 57.308617946304359, 87.980355261972278 57.308853611491088, 87.978644763233547 57.307592366603615, 87.976451455207325 57.306829871121607, 87.97478900014336 57.306541420592673, 87.973169000143358 57.306494420592678, 87.9706438142001 57.306704020275184, 87.968757490181943 57.3071867770516, 87.965713974641432 57.3083133470885, 87.957039185608636 57.3129327969003, 87.94248541802429 57.313624957590932, 87.941300003708974 57.313046314670906, 87.94187783541409 57.308783937941186, 87.946707887817453 57.306580986283727, 87.956071890450076 57.306450903523107, 87.963988657768454 57.305852133843644, 87.968117263500474 57.304114836221657, 87.970688086207318 57.301262822250756, 87.970926323138087 57.300670887062715, 87.96967393607477 57.29604473073887, 87.969253723255946 57.295667515940991, 87.9637936492442 57.2930824064045, 87.95604460233379 57.2911290897528, 87.941192602333828 57.29132808975281, 87.931097589978833 57.295670962435075, 87.924391656847959 57.296752238778041, 87.920755437702624 57.296766349516552, 87.916783463385187 57.296504466585979, 87.915630646343217 57.295266931875481, 87.914829399423908 57.294816256830643, 87.914623240068224 57.292663752039708, 87.915669797376893 57.2914394724566, 87.9157526076651 57.290704719348767, 87.916475213266438 57.290136963629628, 87.91693065871776 57.2892377224793, 87.917117779287508 57.287294991040945, 87.916783946229515 57.286302094028613, 87.919231962419374 57.283015966838505, 87.9194374906558 57.282376087164685, 87.919368644532113 57.282042075479225, 87.91892683581041 57.281535624191967, 87.915612835810421 57.279678624191995, 87.911679134864428 57.278392680451404, 87.909655023978118 57.276812068339709, 87.90735048894247 57.276087261943495, 87.906828742887654 57.27531075915045, 87.908961268475579 57.268209659359265, 87.910878650822042 57.266021465201064, 87.916809877101514 57.263456871759253, 87.921439822691184 57.260889057385356, 87.921875891906652 57.260402447173959, 87.924801863777176 57.253440388942252, 87.930612072558816 57.25048747364324, 87.9309823813153 57.250163488510687, 87.933315381315325 57.246778488510706, 87.93349181812475 57.2461919286186, 87.933293140715847 57.245612523974209, 87.930715140715819 57.242161523974168, 87.930222583666563 57.2418088027961, 87.922485666842775 57.239373071523204, 87.8957276668428 57.241098071523226, 87.884896521125526 57.246651369699094, 87.876479312196736 57.252446492999219, 87.85756027528177 57.256812500117093, 87.847417748919966 57.255702930750722, 87.8468799690165 57.2557937102264, 87.83605084541297 57.2652337584024, 87.83304469311868 57.26691706370341, 87.8217612375357 57.264284160638375, 87.810558294601762 57.265716018741152, 87.807118385808664 57.26561365653739, 87.801483743620281 57.261500554317458, 87.80041278498669 57.259975917970728, 87.794356784986689 57.256112917970761, 87.79056223479499 57.255554254517037, 87.785118800645563 57.255903260431424, 87.780298152983278 57.257669942482153, 87.77806697647884 57.25892019582534, 87.775975195232093 57.260608675938016, 87.77295715231655 57.263593407934437, 87.772025715873838 57.263987583031664, 87.767790078780507 57.263326865241076, 87.766777691435422 57.262841723474715, 87.765978718525133 57.262042470338685, 87.76566773294455 57.26164876722062, 87.765668810200623 57.261025308221058, 87.766231856493675 57.260060586351791, 87.766760841590866 57.260047566024191, 87.767591111651058 57.259435861526292, 87.768339473366112 57.257889002060615, 87.771310236551315 57.25628501943303, 87.772209593136 57.255450290475949, 87.77594617965579 57.253657652055132, 87.785457179655822 57.247158652055113, 87.785857695862234 57.24659636646247, 87.785798458936029 57.245908566123809, 87.785475668231015 57.245219945953131, 87.7849620435709 57.242011960424584, 87.784837008374609 57.241701471844451, 87.784149193407018 57.241045399388831, 87.784098299638714 57.240337679827924, 87.783648386322668 57.239867246952656, 87.772281346562508 57.238156214630834, 87.7731718438632 57.237519424953248, 87.7744231193454 57.235521603795192, 87.774655720778227 57.234708629763858, 87.774653587304257 57.233960106202645, 87.7744442672612 57.232979963965562, 87.774051043865029 57.232340412721811, 87.774934066364835 57.231133460737858, 87.775123729360018 57.23046218797721, 87.77133609031695 57.22232845817971, 87.770783069044256 57.222030266549879, 87.768008088590221 57.221463709330848, 87.784074637914145 57.212123287352867, 87.784323728856279 57.211278659208695, 87.783594276333147 57.207294843156852, 87.783155910814173 57.206863921758185, 87.732425800582718 57.18144940666447, 87.732383952342772 57.1803994780785, 87.731790007443266 57.17976082479602, 87.721224534961749 57.178994121267834, 87.719811065537215 57.1786383240936, 87.718547699041821 57.177526349098329, 87.71784403345282 57.177277923488546, 87.710659033452828 57.177586923488562, 87.708830093125471 57.177922432631377, 87.708310930075626 57.178195862212561, 87.708034518376124 57.178713443684963, 87.7080960249189 57.179296976848882, 87.7085537030481 57.179908016745067, 87.7061219420663 57.179482831542721, 87.695596787641037 57.175859557028232, 87.6877760783828 57.176682548424921, 87.681278297381439 57.174728488114873, 87.6706564465789 57.170531955371196, 87.661784121616435 57.169893184209982, 87.652059869589948 57.16745430113739, 87.647099273761228 57.164595673584657, 87.6369180035934 57.161049383942064, 87.6267268433123 57.154381074753033, 87.626191834686651 57.154217095703906, 87.615422834686669 57.154068095703884, 87.6088358010585 57.155712781074122, 87.6011623626004 57.154489092771428, 87.597797114534231 57.154164263012888, 87.597316224256588 57.154054310713228, 87.596966770161771 57.153688195909766, 87.596445525761922 57.153511178068776, 87.594859330551472 57.153387168603963, 87.591766242666438 57.153457859847151, 87.590287244227923 57.15416375900535, 87.588781343057889 57.154303179891109, 87.584358343057914 57.155728179891092, 87.583852854929262 57.156096544445674, 87.582989245957393 57.15779994425673, 87.581957512476208 57.158426845250268, 87.57960988708173 57.158504254613575, 87.578234461184181 57.158833782841768, 87.577451461184225 57.159293782841743, 87.577011302597469 57.1598338757571, 87.576996762611145 57.161656820411416, 87.574987658424178 57.16178588393899, 87.572281857558409 57.162975854716478, 87.569658530622334 57.163538404159411, 87.567275333589535 57.1643073473586, 87.566666641512882 57.164891310610713, 87.566542563156915 57.165330765908195, 87.564394286485509 57.16646433464993, 87.56342322011767 57.1673428915634, 87.561990718713673 57.170379356030395, 87.5606340135657 57.170669875614429, 87.558252966684023 57.1708935788094, 87.555565848369341 57.170913157176038, 87.5538178666365 57.170597372110123, 87.550344710227179 57.178098448863651, 87.456911710227175 57.37827144886365, 87.362737710227179 57.578397448863647, 87.267809710227183 57.77847344886365, 87.255429262755143 57.804351888327375)),POLYGON ((87.5587038528605 57.160044965779, 87.56030548019568 57.159344694771967, 87.5620930575925 57.159080226897004, 87.564149057592545 57.157994226897017, 87.566000879383537 57.156746897528251, 87.566242938958126 57.156515061263377, 87.566578795654451 57.155625262944895, 87.5665431795642 57.153520461004852, 87.5659068763252 57.152515148693766, 87.564616634707477 57.1514940312064, 87.563389378769585 57.150774360232774, 87.563033400394616 57.150694316244724, 87.5587038528605 57.160044965779)),POLYGON ((108.76574475535003 51.454772536776616, 108.7685097080291 51.455694964508318, 108.77278107695128 51.457313262886615, 108.7734577963314 51.457318702170831, 108.77375760471155 51.457151104179786, 108.77418376795677 51.456487742058172, 108.77422319881266 51.453742961486917, 108.77446852453508 51.453119445016675, 108.77603345561265 51.452365312203341, 108.77966330498651 51.451850966110968, 108.78067613890859 51.451388038191894, 108.78509143698049 51.44585647123651, 108.78530796160619 51.44522623722262, 108.78508042545597 51.444599894563893, 108.78382157920821 51.44377348949763, 108.78404003374553 51.44303935046613, 108.78455772483623 51.442127579239283, 108.78403180081781 51.43929758893097, 108.78463026476001 51.4379028561638, 108.78493206796628 51.437532854368285, 108.79052766912169 51.4371754260339, 108.79365004460856 51.436349112892223, 108.798884842252 51.436205492906979, 108.80061583792183 51.436016122162236, 108.80116765812547 51.436489729214728, 108.80169545844667 51.438048248664032, 108.80219960280208 51.438407128564684, 108.80635242886888 51.438511594805334, 108.80793860267795 51.438722138022143, 108.81017842164195 51.438475929577521, 108.81349006779821 51.43686574741821, 108.81445239334245 51.436897374742067, 108.81472370341849 51.437076347840289, 108.8160442278364 51.439775438368535, 108.81773527060018 51.441393080473311, 108.82415435637758 51.44349197258348, 108.82477372436475 51.443470436006287, 108.8260519104944 51.44300412906648, 108.82810007418091 51.4470968339244, 108.82839181230796 51.448840343677645, 108.82908563294524 51.449856519114817, 108.83033773579579 51.450555623179461, 108.83367973146606 51.451821711963468, 108.83816530521548 51.454372402356945, 108.8421442088036 51.45692481066007, 108.84566041446762 51.457303550268492, 108.85073305685111 51.459500736771382, 108.85172149865502 51.459192240750966, 108.85653887898044 51.456415391638004, 108.86066932544762 51.453289498981704, 108.86129440345751 51.452643644839881, 108.86143699173788 51.452133065007125, 108.86102821866587 51.45001686624245, 108.8632972923118 51.449172686688762, 108.86744272675975 51.447948920482062, 108.87689677564336 51.445484038845152, 108.8838884562535 51.442719998935324, 108.88956610117864 51.440146744397993, 108.89556838769643 51.438083906812487, 108.89620837468121 51.437455071142196, 108.89621986782888 51.43684479062955, 108.89570596840289 51.436069478137767, 108.89521962501388 51.43579430874064, 108.89438814774769 51.435623985802913, 108.89395344931869 51.435022903422343, 108.89290212156824 51.434615116114962, 108.89133060967623 51.434252637825885, 108.88991081992266 51.434168192403369, 108.88609247164035 51.4344324728774, 108.88447057998882 51.433620686783335, 108.8869076782192 51.4289052272021, 108.88722828330552 51.427889630626417, 108.88733039492115 51.4267184763011, 108.886930173101 51.425185242391755, 108.88616117310102 51.423527242391735, 108.88526628416373 51.422175724743717, 108.88424937404611 51.421195398496813, 108.8830653103596 51.420672944908965, 108.88181362107898 51.420444586796123, 108.8805990411914 51.420378823088157, 108.87941693750172 51.420612347913973, 108.87728934648278 51.421466393627895, 108.87596897497259 51.422198760124488, 108.87430583536688 51.423781997805293, 108.87293335050089 51.424784355939252, 108.87132823624945 51.427124570124448, 108.87092782895473 51.428114424910277, 108.87094016312804 51.428729756424438, 108.8663067002614 51.432702941071064, 108.86475494588692 51.433119137190708, 108.86360918029793 51.433645209867272, 108.86352733435051 51.433465778367143, 108.864951244934 51.432189019407957, 108.8675778653555 51.429206410992521, 108.86835906442273 51.427435614504844, 108.86848106442277 51.426576614504853, 108.86836094949371 51.425454578643766, 108.86782498690896 51.424323726096169, 108.86701662330013 51.423394392240866, 108.86554930991407 51.422439302021537, 108.86809662232736 51.42188567161832, 108.86980844335604 51.422152006859633, 108.87097990343119 51.421989085894033, 108.87513302929544 51.420530067418682, 108.87676250065123 51.419384096689079, 108.87741842066093 51.418583417268657, 108.87904639432121 51.417590567714072, 108.88114372410615 51.4149870584497, 108.88109681884909 51.4141231791332, 108.88067532914668 51.413713676818148, 108.8784330320789 51.41331784730049, 108.87706981518363 51.413286567950834, 108.87661503549251 51.412667518193146, 108.87549358124392 51.412136528195823, 108.87567598614996 51.411459263085035, 108.87562843041988 51.410563062679792, 108.87524063596582 51.409949951424466, 108.87422077735089 51.409134633196665, 108.87477810297494 51.40840789059331, 108.87471931022282 51.407389047164592, 108.87377565340037 51.406058027917148, 108.87312362424827 51.40469000547899, 108.87234162424831 51.403807005479, 108.87184596626442 51.403502524900063, 108.87100416691632 51.403661745337544, 108.8706539508611 51.404126217053161, 108.86827804431643 51.410435066076325, 108.85691029234353 51.416315340997031, 108.85249852114194 51.418866736661329, 108.84141377359684 51.424840219570839, 108.83794303586458 51.425289092691756, 108.83259776918457 51.426290862503613, 108.83108843502782 51.4231150599079, 108.83350613893265 51.421894958532882, 108.83530666108567 51.4207266107734, 108.83682343741768 51.418987275672961, 108.84336171169923 51.412734177834473, 108.84581159587022 51.41074164421623, 108.84723333862715 51.409811911242222, 108.84854611167131 51.408314168994494, 108.84896874350896 51.4080210229931, 108.85197330045203 51.406891723345922, 108.85538179303944 51.404832615053166, 108.85721718694076 51.403873798312908, 108.86075268475639 51.4023593371735, 108.86217808601992 51.401496083823446, 108.86287989604051 51.400655034934509, 108.86323689604052 51.399914034934504, 108.86422903423787 51.39680097494319, 108.864067184243 51.395904632108589, 108.86355685416609 51.395552429134582, 108.8551767638679 51.395727313433234, 108.83718159122498 51.396654743312318, 108.83938050035148 51.393149081563386, 108.83921517083978 51.392283896041533, 108.83842978078909 51.391885094959619, 108.79447570845012 51.391234569456586, 108.76574475535003 51.454772536776616)))")]
        public void SearchByGeometryIn2Hemisphere(string wkt)
        {
            var connSql2016 = getConnectionServer2016.Invoke();
            var connPg = getConnectionPg9.Invoke();
            var connSql2008 = getConnection.Invoke();
            
            connSql2016.Open();
            connPg.Open();
            connSql2008.Open();

            var sqlGeometryCompareMethod = "STIntersects";
            
            var validGeometry = $"(GEOMETRY::STGeomFromText(@geometry, 4326).MakeValid())"; //Force to valid geometry
            validGeometry = $"({validGeometry}.STUnion({validGeometry}.STStartPoint()))"; //Forces the correct the geometry ring orientation

            var sqlWhere =
                $"coordinates.{sqlGeometryCompareMethod}(GEOGRAPHY::STGeomFromText({validGeometry}.STAsText(),4326))=1";

            
            var sqlServerWhere =
                @"select * from demo where coordinates.STIntersects(GEOGRAPHY::STGeomFromText('" + wkt + "',4326))=1";

            var sqlServer2008Where =
                @"select * from [demo_picture] where coordinates.STIntersects(GEOGRAPHY::STGeomFromText('" + wkt + "',4326))=1";

            var postgresWhere = @"select * from demo where ST_Intersects(coordinates,ST_GeographyFromText('" + wkt + "'))";

            _out.WriteLine("pg starts");

            var sw = new Stopwatch();
            sw.Start();
            connPg.Execute(postgresWhere,commandTimeout:500);
            sw.Stop();
            _out.WriteLine($"PgElapsed {sw.ElapsedMilliseconds}");
            
            sw.Reset();

            _out.WriteLine("sql starts");
            sw.Start();
            connSql2016.Execute(sqlServerWhere, commandTimeout: 500);
            sw.Stop();
            _out.WriteLine($"Sql2016Elapsed {sw.ElapsedMilliseconds}");

            _out.WriteLine("remote sql 2008");
            sw.Start();
            try
            {
                connSql2008.Execute(sqlServer2008Where, commandTimeout: 500);
                sw.Stop();
                _out.WriteLine($"Sql2008Elapsed {sw.ElapsedMilliseconds}");
            }
            catch (Exception e)
            {
                _out.WriteLine($"Sql2008 Error {e.Message}");
            }
            
        }
    }



    

    
}
